// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_navigation_msgs:msg/PointOfInterestStatus.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST_STATUS__STRUCT_HPP_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestStatus __attribute__((deprecated))
#else
# define DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestStatus __declspec(deprecated)
#endif

namespace automotive_navigation_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PointOfInterestStatus_
{
  using Type = PointOfInterestStatus_<ContainerAllocator>;

  explicit PointOfInterestStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->guid = 0ull;
      this->distance = 0.0f;
      this->heading = 0.0f;
      this->x_position = 0.0f;
      this->y_position = 0.0f;
      this->params = "";
    }
  }

  explicit PointOfInterestStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : params(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->guid = 0ull;
      this->distance = 0.0f;
      this->heading = 0.0f;
      this->x_position = 0.0f;
      this->y_position = 0.0f;
      this->params = "";
    }
  }

  // field types and members
  using _guid_type =
    uint64_t;
  _guid_type guid;
  using _distance_type =
    float;
  _distance_type distance;
  using _heading_type =
    float;
  _heading_type heading;
  using _x_position_type =
    float;
  _x_position_type x_position;
  using _y_position_type =
    float;
  _y_position_type y_position;
  using _params_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _params_type params;

  // setters for named parameter idiom
  Type & set__guid(
    const uint64_t & _arg)
  {
    this->guid = _arg;
    return *this;
  }
  Type & set__distance(
    const float & _arg)
  {
    this->distance = _arg;
    return *this;
  }
  Type & set__heading(
    const float & _arg)
  {
    this->heading = _arg;
    return *this;
  }
  Type & set__x_position(
    const float & _arg)
  {
    this->x_position = _arg;
    return *this;
  }
  Type & set__y_position(
    const float & _arg)
  {
    this->y_position = _arg;
    return *this;
  }
  Type & set__params(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->params = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestStatus
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_navigation_msgs__msg__PointOfInterestStatus
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterestStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PointOfInterestStatus_ & other) const
  {
    if (this->guid != other.guid) {
      return false;
    }
    if (this->distance != other.distance) {
      return false;
    }
    if (this->heading != other.heading) {
      return false;
    }
    if (this->x_position != other.x_position) {
      return false;
    }
    if (this->y_position != other.y_position) {
      return false;
    }
    if (this->params != other.params) {
      return false;
    }
    return true;
  }
  bool operator!=(const PointOfInterestStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PointOfInterestStatus_

// alias to use template instance with default allocator
using PointOfInterestStatus =
  automotive_navigation_msgs::msg::PointOfInterestStatus_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_navigation_msgs

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__DETAIL__POINT_OF_INTEREST_STATUS__STRUCT_HPP_
